/// <reference types="react" />
import { Editor, EditorInitArgs, EditorTheme, KogitoEditorEnvelopeContextType } from "@kie-tools-core/editor/dist/api";
import { Notification } from "@kie-tools-core/notifications/dist/api";
import { Position } from "monaco-editor";
import { ServerlessWorkflowTextEditorChannelApi } from "../api";
export interface ServerlessWorkflowTextEditorApi extends Editor {
    moveCursorToNode(nodeName: string): void;
    moveCursorToPosition(position: Position): void;
}
export declare class ServerlessWorkflowTextEditorView implements ServerlessWorkflowTextEditorApi {
    private readonly envelopeContext;
    private readonly initArgs;
    private readonly editorRef;
    af_isReact: boolean;
    af_componentId: "serverless-workflow-text-editor";
    af_componentTitle: "Serverless Workflow Text Editor";
    constructor(envelopeContext: KogitoEditorEnvelopeContextType<ServerlessWorkflowTextEditorChannelApi>, initArgs: EditorInitArgs);
    getElementPosition(): Promise<import("@kie-tools-core/guided-tour/dist/api").Rect>;
    setContent(path: string, content: string): Promise<void>;
    getContent(): Promise<string>;
    getPreview(): Promise<string | undefined>;
    af_componentRoot(): JSX.Element;
    undo(): Promise<void>;
    redo(): Promise<void>;
    validate(): Promise<Notification[]>;
    setTheme(theme: EditorTheme): Promise<void>;
    moveCursorToNode(nodeName: string): void;
    moveCursorToPosition(position: Position): void;
}
//# sourceMappingURL=ServerlessWorkflowTextEditorView.d.ts.map